# Advanced User Guide

## Additional Features

The main [Tutorial - User Guide](../tutorial/){.internal-link target=_blank} should be enough to give you a tour through all the main features of **ReadyAPI**.

In the next sections you will see other options, configurations, and additional features.

!!! tip
    The next sections are **not necessarily "advanced"**.

    And it's possible that for your use case, the solution is in one of them.

## Read the Tutorial first

You could still use most of the features in **ReadyAPI** with the knowledge from the main [Tutorial - User Guide](../tutorial/){.internal-link target=_blank}.

And the next sections assume you already read it, and assume that you know those main ideas.

## External Courses

Although the [Tutorial - User Guide](../tutorial/){.internal-link target=_blank} and this **Advanced User Guide** are written as a guided tutorial (like a book) and should be enough for you to **learn ReadyAPI**, you might want to complement it with additional courses.

Or it might be the case that you just prefer to take other courses because they adapt better to your learning style.

Some course providers ✨ [**sponsor ReadyAPI**](../help-readyapi.md#sponsor-the-author){.internal-link target=_blank} ✨, this ensures the continued and healthy **development** of ReadyAPI and its **ecosystem**.

And it shows their true commitment to ReadyAPI and its **community** (you), as they not only want to provide you a **good learning experience** but also want to make sure you have a **good and healthy framework**, ReadyAPI. 🙇

You might want to try their courses:

* <a href="https://training.talkpython.fm/readyapi-courses" class="external-link" target="_blank">Talk Python Training</a>
* <a href="https://testdriven.io/courses/tdd-readyapi/" class="external-link" target="_blank">Test-Driven Development</a>
